]> git.proxmox.com Git - ceph.git/blob - ceph/src/zstd/programs/zstdgrep
import 15.2.0 Octopus source
[ceph.git] / ceph / src / zstd / programs / zstdgrep
1 #!/bin/sh
2 #
3 # Copyright (c) 2003 Thomas Klausner.
4 #
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions
7 # are met:
8 # 1. Redistributions of source code must retain the above copyright
9 # notice, this list of conditions and the following disclaimer.
10 # 2. Redistributions in binary form must reproduce the above copyright
11 # notice, this list of conditions and the following disclaimer in the
12 # documentation and/or other materials provided with the distribution.
13 #
14 # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
15 # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
16 # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
17 # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
18 # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
19 # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
20 # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
21 # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
22 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
23 # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
24
25 grep=${GREP:-grep}
26 zcat=${ZCAT:-zstdcat}
27
28 endofopts=0
29 pattern_found=0
30 grep_args=""
31 hyphen=0
32 silent=0
33
34 prog=${0##*/}
35
36 # handle being called 'zegrep' or 'zfgrep'
37 case $prog in
38 *egrep*) prog=zegrep; grep_args='-E';;
39 *fgrep*) prog=zfgrep; grep_args='-F';;
40 *) prog=zstdgrep;;
41 esac
42
43 # skip all options and pass them on to grep taking care of options
44 # with arguments, and if -e was supplied
45
46 while [ "$#" -gt 0 ] && [ "${endofopts}" -eq 0 ]; do
47 case "$1" in
48 # from GNU grep-2.5.1 -- keep in sync!
49 -[ABCDXdefm])
50 if [ "$#" -lt 2 ]; then
51 printf '%s: missing argument for %s flag\n' "${prog}" "$1" >&2
52 exit 1
53 fi
54 case "$1" in
55 -e)
56 pattern="$2"
57 pattern_found=1
58 shift 2
59 break
60 ;;
61 *)
62 ;;
63 esac
64 grep_args="${grep_args} $1 $2"
65 shift 2
66 ;;
67 --)
68 shift
69 endofopts=1
70 ;;
71 -)
72 hyphen=1
73 shift
74 ;;
75 -h)
76 silent=1
77 shift
78 ;;
79 -*)
80 grep_args="${grep_args} $1"
81 shift
82 ;;
83 *)
84 # pattern to grep for
85 endofopts=1
86 ;;
87 esac
88 done
89
90 # if no -e option was found, take next argument as grep-pattern
91 if [ "${pattern_found}" -lt 1 ]; then
92 if [ "$#" -ge 1 ]; then
93 pattern="$1"
94 shift
95 elif [ "${hyphen}" -gt 0 ]; then
96 pattern="-"
97 else
98 printf '%s: missing pattern\n' "${prog}" >&2
99 exit 1
100 fi
101 fi
102
103 EXIT_CODE=0
104 # call grep ...
105 if [ "$#" -lt 1 ]; then
106 # ... on stdin
107 set -f # Disable file name generation (globbing).
108 # shellcheck disable=SC2086
109 "${zcat}" -fq - | "${grep}" ${grep_args} -- "${pattern}" -
110 EXIT_CODE=$?
111 set +f
112 else
113 # ... on all files given on the command line
114 if [ "${silent}" -lt 1 ] && [ "$#" -gt 1 ]; then
115 grep_args="-H ${grep_args}"
116 fi
117 set -f
118 while [ "$#" -gt 0 ]; do
119 # shellcheck disable=SC2086
120 "${zcat}" -fq -- "$1" | "${grep}" --label="${1}" ${grep_args} -- "${pattern}" -
121 [ "$?" -ne 0 ] && EXIT_CODE=1
122 shift
123 done
124 set +f
125 fi
126
127 exit "${EXIT_CODE}"